using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Xml;
using System.Text.RegularExpressions;
using com.ibm.gre;


namespace WindowsApplication1
{
	/// <summary>
	/// Form1 is the main application form containing
	/// Server and login fields and a Text Box
	/// and parameter fields for testing code snippets.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtServerNamePort;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox txtUserName;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.Label label4;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ComboBox comboBoxDataSource;

		private ClientSession m_factory = null;

		private bool dirty = true;
		private System.Windows.Forms.TextBox textOption1;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox textOption2;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.TextBox textOption3;
		private System.Windows.Forms.TextBox textOption4;
		private System.Windows.Forms.Button button2;
		private bool dirtyServer = false;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.txtServerNamePort = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.txtUserName = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.comboBoxDataSource = new System.Windows.Forms.ComboBox();
			this.textOption1 = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.textOption2 = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.textOption3 = new System.Windows.Forms.TextBox();
			this.textOption4 = new System.Windows.Forms.TextBox();
			this.button2 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.AutoSize = false;
			this.textBox1.Location = new System.Drawing.Point(8, 192);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBox1.Size = new System.Drawing.Size(504, 208);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "textBox1";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(432, 416);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(80, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "Execute";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(96, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "ServerName:Port";
			// 
			// txtServerNamePort
			// 
			this.txtServerNamePort.Location = new System.Drawing.Point(128, 16);
			this.txtServerNamePort.Name = "txtServerNamePort";
			this.txtServerNamePort.Size = new System.Drawing.Size(240, 20);
			this.txtServerNamePort.TabIndex = 3;
			this.txtServerNamePort.Text = "localhost:9080";
			this.txtServerNamePort.TextChanged += new System.EventHandler(this.txtServerNamePort_TextChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 40);
			this.label2.Name = "label2";
			this.label2.TabIndex = 4;
			this.label2.Text = "User Name";
			// 
			// txtUserName
			// 
			this.txtUserName.Location = new System.Drawing.Point(128, 40);
			this.txtUserName.Name = "txtUserName";
			this.txtUserName.Size = new System.Drawing.Size(240, 20);
			this.txtUserName.TabIndex = 5;
			this.txtUserName.Text = "administrator";
			this.txtUserName.TextChanged += new System.EventHandler(this.txtUserName_TextChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 64);
			this.label3.Name = "label3";
			this.label3.TabIndex = 6;
			this.label3.Text = "Password";
			// 
			// txtPassword
			// 
			this.txtPassword.Location = new System.Drawing.Point(128, 64);
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.PasswordChar = '*';
			this.txtPassword.Size = new System.Drawing.Size(240, 20);
			this.txtPassword.TabIndex = 7;
			this.txtPassword.Text = "cronos";
			this.txtPassword.TextChanged += new System.EventHandler(this.txtPassword_TextChanged);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 88);
			this.label4.Name = "label4";
			this.label4.TabIndex = 9;
			this.label4.Text = "Datasource";
			// 
			// comboBoxDataSource
			// 
			this.comboBoxDataSource.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxDataSource.Location = new System.Drawing.Point(128, 88);
			this.comboBoxDataSource.Name = "comboBoxDataSource";
			this.comboBoxDataSource.Size = new System.Drawing.Size(240, 21);
			this.comboBoxDataSource.TabIndex = 10;
			this.comboBoxDataSource.SelectedIndexChanged += new System.EventHandler(this.comboBoxDataSource_SelectedIndexChanged);
			// 
			// textOption1
			// 
			this.textOption1.Location = new System.Drawing.Point(128, 120);
			this.textOption1.Name = "textOption1";
			this.textOption1.Size = new System.Drawing.Size(88, 20);
			this.textOption1.TabIndex = 11;
			this.textOption1.Text = "0";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(16, 120);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(64, 16);
			this.label5.TabIndex = 12;
			this.label5.Text = "option 1";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(248, 120);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(72, 16);
			this.label6.TabIndex = 13;
			this.label6.Text = "option 2";
			// 
			// textOption2
			// 
			this.textOption2.Location = new System.Drawing.Point(344, 120);
			this.textOption2.Name = "textOption2";
			this.textOption2.Size = new System.Drawing.Size(88, 20);
			this.textOption2.TabIndex = 14;
			this.textOption2.Text = "0";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(16, 152);
			this.label7.Name = "label7";
			this.label7.TabIndex = 15;
			this.label7.Text = "option 3";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(248, 152);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(64, 23);
			this.label8.TabIndex = 16;
			this.label8.Text = "option 4";
			// 
			// textOption3
			// 
			this.textOption3.Location = new System.Drawing.Point(128, 152);
			this.textOption3.Name = "textOption3";
			this.textOption3.Size = new System.Drawing.Size(88, 20);
			this.textOption3.TabIndex = 17;
			this.textOption3.Text = "0";
			// 
			// textOption4
			// 
			this.textOption4.Location = new System.Drawing.Point(344, 152);
			this.textOption4.Name = "textOption4";
			this.textOption4.Size = new System.Drawing.Size(88, 20);
			this.textOption4.TabIndex = 18;
			this.textOption4.Text = "0";
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(384, 16);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(80, 24);
			this.button2.TabIndex = 19;
			this.button2.Text = "Re-Connect";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(520, 453);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.textOption4);
			this.Controls.Add(this.textOption3);
			this.Controls.Add(this.textOption2);
			this.Controls.Add(this.textOption1);
			this.Controls.Add(this.txtPassword);
			this.Controls.Add(this.txtUserName);
			this.Controls.Add(this.txtServerNamePort);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.comboBoxDataSource);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		//This is a very simple example of a Query Image that can be used in the runQuery method
		//This query will get all FilePlanComponents who's Id is greater than 0 (all of them)
		//Starting at position 0 returning 40 items and sorted by FilePlanComponent ID in descending order
		//Returning the FilePlanComponent ID, Name and Title fields
		private string getQuery()
		{
			string str =
				"<Fields>" +
				"<Field FlPlnCmpntAttrDefColNm=\"FlPlnCmpntDefID\">0</Field>" +
				"<Field FlPlnCmpntAttrDefColNm=\"QueryImage\">" +
				"<![CDATA[<ReportTemplate><Version>4.1.1</Version><ReportLayout/><Scope/><BlockSize>40</BlockSize><BlockStart>0</BlockStart><Distinct>0</Distinct><Query><Condition><FieldExpression><FieldName>TS_FlPlnCmpnt.FlPlnCmpntID</FieldName><FieldOperator>></FieldOperator><FieldValue>0</FieldValue></FieldExpression></Condition><SortFields><SortField Order=\"desc\">TS_FlPlnCmpnt.FlPlnCmpntID</SortField></SortFields><OutputFields><OutputField>TS_FlPlnCmpnt.FlPlnCmpntID</OutputField><OutputField>TS_FlPlnCmpnt.FlPlnCmpntNm</OutputField><OutputField>TS_FlPlnCmpnt.FlPlnCmpntTtl</OutputField></OutputFields></Query></ReportTemplate>]]>" +
				"</Field>" +
				"</Fields>";
			return str;
		}
		

		private string getSuspensionQuery()
		{
			string str =
				"<Fields>" +
				"<Field FlPlnCmpntAttrDefColNm=\"FlPlnCmpntDefID\">-14</Field>" +
				"<Field FlPlnCmpntAttrDefColNm=\"QueryImage\">" +
				"<![CDATA[<ReportTemplate><Version>4.1.1</Version><ReportLayout/><Scope/><BlockSize>40</BlockSize><BlockStart>0</BlockStart><Distinct>0</Distinct><Query><Condition><FieldExpression><FieldName>TS_FlPlnCmpnt.FlPlnCmpntID</FieldName><FieldOperator>=</FieldOperator><FieldValue>35</FieldValue></FieldExpression></Condition><SortFields/><OutputFields><OutputField>TS_LfCclSpsn.LfCclSpsnID</OutputField><OutputField>TS_LfCclSpsn.LfCclSpsnNm</OutputField><OutputField>TS_FlPlnCmpnt.FlPlnCmpntID</OutputField></OutputFields></Query></ReportTemplate>]]>" +
				"</Field>" +
				"</Fields>";
			return str;
		}

		//Try out some methods here
		private void button1_Click(object sender, System.EventArgs e)
		{
			textBox1.Clear();
			try
			{
				//Re login if server or login values have changed 
				doLogin();

				int option = System.Convert.ToInt32(textOption1.Text);
				int option2 =  System.Convert.ToInt32(textOption2.Text);
				int option3 =  System.Convert.ToInt32(textOption3.Text);
				int option4 =  System.Convert.ToInt32(textOption4.Text);


				//textBox1.Text = m_factory.getSerializedClientController();

				//textBox1.Text = m_factory.getDefinitionController().getComponentDefinitionList();
				
				//textBox1.Text = m_factory.getFilePlanComponentController().getPermissionList(4,5,"",0,0);
				
				//textBox1.Text = m_factory.getTemplateController().getSystemComponent(-3,5,33,option);

				//textBox1.Text = m_factory.getQueryController().getQueryById(option);
				
				//textBox1.Text = m_factory.getLifeCycleDesignController().getComponentListForLifeCycleSuspension(option);

				//textBox1.Text = m_factory.getQueryController().runQuery(getQuery(),option);
				
				textBox1.Text = m_factory.getQueryController().runQuery(getSuspensionQuery(),option);

				//textBox1.Text = m_factory.getComponentDesignController().getDefaultById(option);

				//textBox1.Text = m_factory.getComponentDesignController().getDefaultImageById(option);

				//textBox1.Text = m_factory.getSecurityController().getExtendedPermissionList(option,"",0,0);

				//textBox1.Text = m_factory.getTemplateController().getNewComponent(option,option2,option3,option4);

				//textBox1.Text = m_factory.getNavigationController().getTargetList(1,0,0,"",0,0);
				
				/*
				string xml = 
					"<Fields>" +
					"<Field FlPlnCmpntAttrDefColNm=\"FlPlnCmpntNm\">Test3</Field>" +
					"<Field FlPlnCmpntAttrDefColNm=\"RecHsID\">1</Field>" +
					"<Field FlPlnCmpntAttrDefColNm=\"XtRecID\">Test3</Field>" +
					"</Fields>";
				*/
				
				//textBox1.Text = "New FilePlanComponentID = " + m_factory.getFilePlanComponentController().addFilePlanComponent(5,xml,13);
				
				//string str = "<List><Item RecHsID=\"22\" XtRecID=\"Library 1/Document 2343\" /></List>";
				//textBox1.Text = m_factory.getFilePlanComponentController().getAllowedHostActionList(str,9999);

				//textBox1.Text = m_factory.getFilePlanComponentController().getFilePlanComponentField(2,"TS_CustomIntegerField");

			}
			catch(System.Net.WebException we)
			{
				textBox1.Text = "WebException" +
								"\r\n\r\nMessage: " + we.Message +
								"\r\n\r\nSource: " + we.Source +
								"\r\n\r\nResponse : " + we.Response +
								"\r\n\r\nStatus : " + we.Status +
								"\r\n\r\nTargetSite : " + we.TargetSite +
								"\r\n\r\nStackTrace: " + we.StackTrace;
			}
			catch(System.Web.Services.Protocols.SoapException s)
			{
				textBox1.Text = s.Message;
				if(checkForTimeOut(s.Message))
				{
					m_factory.reLogin();
					textBox1.Text = "SESSION BEAN TIMED OUT\r\n\r\nYou were logged in again.\r\n\r\nTry again.";
					return;
				}
				//If the message contains XML display the Error elements
				if(!displayXMLMessage(s.Message))
				{
					//Show exception information
					textBox1.Text = "SoapException" +
						"\r\n\r\nCode:\t" + s.Code +
						"\r\n\r\nMessage:\t" + s.Message +
						"\r\n\r\nDetail:\t" + s.Detail +
						"\r\n\r\nTargetSite:\t" + s.TargetSite +
						"\r\n\r\nActor:\t" + s.Actor +
						"\r\n\r\nStackTrace:\t" + s.StackTrace;
				}
			}
		}

		private bool checkForTimeOut(string message)
		{
			Regex r = new Regex(".*com.ibm.ejs.container.SessionBeanTimeoutException.*");
			return r.IsMatch(message);
		}

		//Parse out Records Manager Exception Error elements
		private bool displayXMLMessage(string message)
		{
			XmlDocument doc = new XmlDocument();
			try
			{
				doc.LoadXml(message);
				textBox1.AppendText("Records Manager Exception");
				XmlNodeList errorNodes = doc.GetElementsByTagName("Error");
				for(int i = 0; i < errorNodes.Count; i++)
				{
					XmlNodeList errElements = errorNodes.Item(i).ChildNodes;
					for(int l = 0; l < errElements.Count; l++)
					{
						XmlNode errNode = errElements.Item(l);
						textBox1.AppendText("\r\n\r\n" + errNode.Name + ": " + errNode.InnerText);
					}
				}
				return true;
			}
			catch(XmlException e)
			{
				System.Console.Error.WriteLine(e.Message);
				return false;
			}
		}

		private void doLogin()
		{
			//If the name of the server was changed create a new Factory
			if(dirtyServer)
			{
				m_factory = new ClientSession(txtServerNamePort.Text);
				dirty = true;
				dirtyServer = false;
			}
			//If any login information has changed login again
			if(dirty)
			{
				m_factory.login(txtUserName.Text,txtPassword.Text,comboBoxDataSource.Text,"","en");
				dirty = false;
			}
		}

		private void connect()
		{
			string serverNamePort = txtServerNamePort.Text;
			string dataSourceList;
			try
			{
				if(m_factory != null)
				{
					if(m_factory.getCurrentDataSource() != null)
					{
						textBox1.AppendText("\r\nLogging out from: " + m_factory.getCurrentDataSource());
						m_factory.logout();
						textBox1.AppendText("\r\nLogged Out.");
					}
				}
			}
			catch(System.Net.WebException we)
			{
				textBox1.AppendText("WebException : " + we.Message);
			}
			catch(System.Web.Services.Protocols.SoapException se)
			{
				textBox1.AppendText("SoapException Error Code: " + se.Code + "\n" + se.Detail);
			}
			try
			{
				m_factory = null;

				//Create a new ClientSession using specified Sever Name and Port
				m_factory = new ClientSession(txtServerNamePort.Text);
				
				//Get the XML containing the list of available data sources
				dataSourceList = m_factory.getDataSourceList();
				
				//Parse out the JNDIName values and add to a droplist
				XmlDocument doc = new XmlDocument();
				doc.LoadXml(dataSourceList);
				XmlNodeList nodes = doc.GetElementsByTagName("Item");
				
				comboBoxDataSource.Items.Clear();

				for(int i = 0; i < nodes.Count; i++)
				{
					string str = nodes.Item(i).Attributes.GetNamedItem("JNDIName").Value;
					int index = comboBoxDataSource.Items.Add(str);
				}
				comboBoxDataSource.SelectedIndex = 0;
			}
			catch(System.Net.WebException we)
			{
				textBox1.AppendText("WebException : " + we.Message);
			}
			catch(System.Web.Services.Protocols.SoapException se)
			{
				textBox1.AppendText("SoapException Error Code: " + se.Code + "\n" + se.Detail);
			}
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			connect();
		}

		private void txtServerNamePort_TextChanged(object sender, System.EventArgs e)
		{
			dirtyServer = true;
		}

		private void txtUserName_TextChanged(object sender, System.EventArgs e)
		{
			dirty = true;
		}

		private void txtPassword_TextChanged(object sender, System.EventArgs e)
		{
			dirty = true;
		}

		private void comboBoxDataSource_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			dirty = true;
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			connect();
		}

	}
}
